Index: MuiscOrganizationSystem/settings.py
===================================================================
--- MuiscOrganizationSystem/settings.py	(revision da2058e8143fa9f5ea3a13cd627153d96c156af1)
+++ MuiscOrganizationSystem/settings.py	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -16,4 +16,5 @@
 BASE_DIR = Path(__file__).resolve().parent.parent
 
+
 # Quick-start development settings - unsuitable for production
 # See https://docs.djangoproject.com/en/5.1/howto/deployment/checklist/
@@ -26,4 +27,5 @@
 
 ALLOWED_HOSTS = []
+
 
 # Application definition
@@ -47,5 +49,4 @@
     "django.contrib.messages.middleware.MessageMiddleware",
     "django.middleware.clickjacking.XFrameOptionsMiddleware",
-    'music.middleware.Redirect404ToHomeMiddleware',
 ]
 
@@ -71,4 +72,5 @@
 WSGI_APPLICATION = "MuiscOrganizationSystem.wsgi.application"
 
+
 # Database
 # https://docs.djangoproject.com/en/5.1/ref/settings/#databases
@@ -92,4 +94,5 @@
 }
 
+
 # Password validation
 # https://docs.djangoproject.com/en/5.1/ref/settings/#auth-password-validators
@@ -110,4 +113,5 @@
 ]
 
+
 # Internationalization
 # https://docs.djangoproject.com/en/5.1/topics/i18n/
@@ -121,4 +125,5 @@
 USE_TZ = True
 
+
 # Static files (CSS, JavaScript, Images)
 # https://docs.djangoproject.com/en/5.1/howto/static-files/
@@ -130,4 +135,2 @@
 
 DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"
-
-DATA_UPLOAD_MAX_NUMBER_FIELDS = 10000
Index: music/admin.py
===================================================================
--- music/admin.py	(revision da2058e8143fa9f5ea3a13cd627153d96c156af1)
+++ music/admin.py	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -16,3 +16,2 @@
 admin.site.register(PlaylistTrack, PlaylistTrackAdmin)
 admin.site.register(Track)
-admin.site.register(DeletedCustomerLog)
Index: music/models.py
===================================================================
--- music/models.py	(revision da2058e8143fa9f5ea3a13cd627153d96c156af1)
+++ music/models.py	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -5,5 +5,4 @@
     artist_id = models.AutoField(primary_key=True)
     name = models.CharField(max_length=120, blank=True, null=True)
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     def __str__(self):
@@ -18,5 +17,4 @@
     title = models.CharField(max_length=160)
     artist = models.ForeignKey(Artist, on_delete=models.CASCADE, db_column='artist_id')
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     def __str__(self):
@@ -35,5 +33,12 @@
     birth_date = models.DateTimeField(blank=True, null=True)
     hire_date = models.DateTimeField(blank=True, null=True)
-    deleted_at = models.DateTimeField(null=True, blank=True)
+    address = models.CharField(max_length=70, blank=True, null=True)
+    city = models.CharField(max_length=40, blank=True, null=True)
+    state = models.CharField(max_length=40, blank=True, null=True)
+    country = models.CharField(max_length=40, blank=True, null=True)
+    postal_code = models.CharField(max_length=10, blank=True, null=True)
+    phone = models.CharField(max_length=24, blank=True, null=True)
+    fax = models.CharField(max_length=24, blank=True, null=True)
+    email = models.CharField(max_length=60, blank=True, null=True)
 
     def __str__(self):
@@ -49,7 +54,13 @@
     last_name = models.CharField(max_length=20)
     company = models.CharField(max_length=80, blank=True, null=True)
-    support_rep = models.ForeignKey(Employee, on_delete=models.SET_NULL, blank=True, null=True,
-                                    db_column='support_rep_id')
-    deleted_at = models.DateTimeField(null=True, blank=True)
+    address = models.CharField(max_length=70, blank=True, null=True)
+    city = models.CharField(max_length=40, blank=True, null=True)
+    state = models.CharField(max_length=40, blank=True, null=True)
+    country = models.CharField(max_length=40, blank=True, null=True)
+    postal_code = models.CharField(max_length=10, blank=True, null=True)
+    phone = models.CharField(max_length=24, blank=True, null=True)
+    fax = models.CharField(max_length=24, blank=True, null=True)
+    email = models.CharField(max_length=60)
+    support_rep = models.ForeignKey(Employee, on_delete=models.SET_NULL, blank=True, null=True, db_column='support_rep_id')
 
     def __str__(self):
@@ -63,5 +74,4 @@
     genre_id = models.AutoField(primary_key=True)
     name = models.CharField(max_length=120, blank=True, null=True)
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     def __str__(self):
@@ -75,5 +85,4 @@
     media_type_id = models.AutoField(primary_key=True)
     name = models.CharField(max_length=120, blank=True, null=True)
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     def __str__(self):
@@ -93,5 +102,5 @@
     milliseconds = models.IntegerField()
     bytes = models.IntegerField(blank=True, null=True)
-    deleted_at = models.DateTimeField(null=True, blank=True)
+    unit_price = models.DecimalField(max_digits=10, decimal_places=2)
 
     def __str__(self):
@@ -104,5 +113,5 @@
 class Invoice(models.Model):
     invoice_id = models.AutoField(primary_key=True)
-    customer = models.ForeignKey(Customer, on_delete=models.SET_NULL, db_column='customer_id', null=True)
+    customer = models.ForeignKey(Customer, on_delete=models.CASCADE, db_column='customer_id')
     invoice_date = models.DateTimeField()
     billing_address = models.CharField(max_length=70, blank=True, null=True)
@@ -112,5 +121,4 @@
     billing_postal_code = models.CharField(max_length=10, blank=True, null=True)
     total = models.DecimalField(max_digits=10, decimal_places=2)
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     def __str__(self):
@@ -119,5 +127,4 @@
     class Meta:
         db_table = 'invoice'
-        managed = False
 
 
@@ -126,10 +133,9 @@
     invoice = models.ForeignKey(Invoice, on_delete=models.CASCADE, db_column='invoice_id')
     track = models.ForeignKey(Track, on_delete=models.CASCADE, db_column='track_id')
+    unit_price = models.DecimalField(max_digits=10, decimal_places=2)
     quantity = models.IntegerField()
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     class Meta:
         db_table = 'invoice_line'
-        managed = False
 
 
@@ -137,5 +143,4 @@
     playlist_id = models.AutoField(primary_key=True)
     name = models.CharField(max_length=120, blank=True, null=True)
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     def __str__(self):
@@ -150,5 +155,4 @@
     playlist = models.ForeignKey(Playlist, on_delete=models.CASCADE, db_column='playlist_id')
     track = models.ForeignKey(Track, on_delete=models.CASCADE, db_column='track_id')
-    deleted_at = models.DateTimeField(null=True, blank=True)
 
     class Meta:
@@ -161,47 +165,14 @@
 
 
-class DeletedCustomerLog(models.Model):
-    log_id = models.AutoField(primary_key=True)
-    first_name = models.CharField(max_length=40)
-    last_name = models.CharField(max_length=20)
-    deleted_at = models.DateTimeField()
-    total_spent = models.DecimalField(max_digits=10, decimal_places=2)
-    invoice_count = models.IntegerField()
-    deleted_at = models.DateTimeField(null=True, blank=True)
+#VIEWS
+
+class tracks_count_per_genre(models.Model):
+    genre = models.CharField(max_length=20, blank=True, null=True)
+    count = models.IntegerField(blank=True, null=True)
 
     class Meta:
-        db_table = 'deleted_customer_log'
+        db_table = 'tracks_count_per_genre'
         managed = False
 
     def __str__(self):
-        return f"{self.first_name} {self.last_name} - Deleted on {self.deleted_at} - Total Spent: ${self.total_spent} from {self.invoice_count} invoices"
-
-
-class Price(models.Model):
-    price_id = models.AutoField(primary_key=True)
-    value = models.DecimalField(max_digits=10, decimal_places=2)
-    date = models.DateTimeField()
-    track_id = models.ForeignKey(Track, on_delete=models.DO_NOTHING, db_column='track_id')
-
-    class Meta:
-        managed = False
-        db_table = 'price'
-
-    def __str__(self):
-        return f"{self.track_id} - {self.value} - {self.date}"
-
-
-class PersonalInfo(models.Model):
-    customer = models.OneToOneField(Customer, on_delete=models.CASCADE, related_name='personalinfo')
-    address = models.CharField(max_length=255)
-    city = models.CharField(max_length=100)
-    state = models.CharField(max_length=100, blank=True, null=True)
-    country = models.CharField(max_length=100)
-    postal_code = models.CharField(max_length=20, blank=True, null=True)
-    phone = models.CharField(max_length=20, blank=True, null=True)
-
-    class Meta:
-        managed = False
-        db_table = 'personalinfo'
-    def __str__(self):
-        return f"Personal info for {self.customer.first_name} {self.customer.last_name}"
+        return f"{self.genre} - {self.count}"
Index: music/tests.py
===================================================================
--- music/tests.py	(revision da2058e8143fa9f5ea3a13cd627153d96c156af1)
+++ music/tests.py	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -8,2 +8,6 @@
 django.setup()
 
+from music.models import Artist
+artists = Artist.objects.raw('SELECT * FROM music_artist')
+for artist in artists:
+    print(artist.name)
Index: music/urls.py
===================================================================
--- music/urls.py	(revision da2058e8143fa9f5ea3a13cd627153d96c156af1)
+++ music/urls.py	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -1,28 +1,9 @@
 from django.urls import path
-from django.views.generic import RedirectView
-
 from . import views
 
 urlpatterns = [
-    path('', views.home_page, name='homepage'),
     path('album/', views.album_list, name='album_list'),
     path('artist/', views.artist_list, name='artist_list'),
-    path('artist/avg-track-duration', views.avg_track_duration, name='avg_track_duration'),
-    path('artist/avg-track-price', views.avg_price_per_artist, name='avg_track_price'),
-    path('artist/most-popular', views.rank_list_artists, name='rank_list_artists'),
     path('track/', views.track_list, name='track_list'),
-    path('customer/genres-per-customer', views.genres_per_customer, name='genres_per_customer'),
-    path('customer/invoices-per-customer', views.invoice_per_customer_after_date,
-         name='invoice_per_customer_after_date'),
-    path('customer/artist-per-genre', views.most_popular_artist_per_customer_per_genre,
-         name='most_popular_artist_per_customer_per_genre'),
-    path('customer/most-popular-genre-per-customer', views.most_listened_genre_per_customer,
-         name='most_listened_genre_per_customer'),
-    path('media-type/percentage', views.media_type_percentage, name='media_type_percentage'),
-    path('track/per-genre', views.tracks_count_per_genre, name='track_count_per_genre'),
-    path('customer/rank-list', views.rank_list_most_active_customers, name='rank_list_most_active_customers'),
-    path('employee/batch-update-reports-to/', views.batch_update_reports_to, name='batch_update_reports_to'),
-    path('playlists/add-tracks/', views.add_tracks_to_playlist, name='add_tracks_to_playlist'),
-    path('invoices/add-lines/', views.add_invoice_lines_to_invoice, name='add_invoice_lines_to_invoice'),
-
+    path('track/per_genre', views.tracks_count_per_genre, name='track_count_per_genre'),
 ]
Index: music/views.py
===================================================================
--- music/views.py	(revision da2058e8143fa9f5ea3a13cd627153d96c156af1)
+++ music/views.py	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -1,9 +1,6 @@
-import json
-
 from django.shortcuts import render
 import os
 import django
 from django.db import connection
-from django.shortcuts import redirect
 
 os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'MuiscOrganizationSystem.settings')
@@ -15,54 +12,16 @@
 # Create your views here.
 
-def home_page(request):
-    return render(request, 'home.html')
-
-
-def redirect_to_home(request, exception):
-    return redirect('home_page')
-
-
-## LIST OF ALL ##
 def album_list(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    if search_track:
-        data = Album.objects.filter(title__icontains=search_track).values_list('title', flat=True)
-    else:
-        data = Album.objects.all().values_list('title', flat=True)
-
     heading = request.GET.get('model', 'All Albums')
-    return render(request, 'list.html', {
-        'data': data,
-        'heading': heading,
-        'search_track': search_track,
-    })
+    data = Album.objects.values_list('title', flat=True)
+    return render(request, 'album_list.html', {'data': data, 'heading': heading})
 
 
 def track_list(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    if search_track:
-        data = Track.objects.filter(name__icontains=search_track).values_list('name', flat=True)
-    else:
-        data = Track.objects.all().values_list('name', flat=True)
-
     heading = request.GET.get('model', 'All Tracks')
-    return render(request, 'list.html', {'data': data, 'heading': heading, 'search_track': search_track, })
+    data = Track.objects.values_list('name', flat=True)
+    return render(request, 'album_list.html', {'data': data, 'heading': heading})
 
 
-def artist_list(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    if search_track:
-        data = Artist.objects.filter(name__icontains=search_track).values_list('name', flat=True)
-    else:
-        data = Artist.objects.all().values_list('name', flat=True)
-    heading = request.GET.get('model', 'All Artists')
-
-    return render(request, 'list.html', {'data': data, 'heading': heading, 'search_track': search_track, })
-
-
-## VIEWS ##
 def tracks_count_per_genre(request):
     with connection.cursor() as cursor:
@@ -71,325 +30,12 @@
 
     data = [{'genre': row[0], 'count': row[1]} for row in rows]
+    print(data)
 
     return render(request, 'track_count_per_genre.html', {'data': data})
 
 
-def avg_track_duration(request):
-    with connection.cursor() as cursor:
-        cursor.execute("SELECT * FROM avg_track_duration_per_artist;")
-        rows = cursor.fetchall()
-
-    data = [{'artist': row[0], 'avg': row[1]} for row in rows]
-
-    return render(request, 'avg_track_duration.html', {'data': data})
-
-
-def rank_list_most_active_customers(request):
-    with connection.cursor() as cursor:
-        cursor.execute("SELECT * FROM rank_list_most_active_customers_view;")
-        rows = cursor.fetchall()
-
-    data = [{'name': row[0], 'total_orders': row[1], 'total_money_spent': row[2]} for row in rows]
-
-    return render(request, 'rank_list_most_active_customers.html', {'data': data})
-
-
-def avg_price_per_artist(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    with connection.cursor() as cursor:
-        cursor.execute("SELECT * FROM avg_price_per_artist;")
-        rows = cursor.fetchall()
-
-    if search_track:
-        rows = [row for row in rows if search_track.lower() in row[0].lower()]
-
-    data = [{'name': row[0], 'avg_price_per_track': row[1]} for row in rows]
-
-    return render(request, 'avg_price_per_artist.html', {'data': data, 'search_track': search_track})
-
-
-def rank_list_artists(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    with connection.cursor() as cursor:
-        cursor.execute("SELECT * FROM rank_list_artists;")
-        rows = cursor.fetchall()
-
-    if search_track:
-        rows = [row for row in rows if search_track.lower() in row[0].lower()]
-
-    data = [{'name': row[0], 'num_invoices': row[1], 'money_earned': row[2]} for row in rows]
-
-    return render(request, 'rank_list_artists.html', {'data': data, 'search_track': search_track})
-
-
-def media_type_percentage(request):
-    with connection.cursor() as cursor:
-        cursor.execute("SELECT * FROM media_type_percentage;")
-        rows = cursor.fetchall()
-
-    data = [{'name': row[0], 'num_of_tracks': row[1], 'percentage': row[2]} for row in rows]
-
-    return render(request, 'media_type_percentage.html', {'data': data})
-
-
-def most_listened_genre_per_customer(request):
-    with connection.cursor() as cursor:
-        cursor.execute("SELECT * FROM most_listened_genre_per_customer;")
-        rows = cursor.fetchall()
-
-    data = [{'first_name': row[0], 'last_name': row[1], 'most_listened_genre': row[2]} for row in rows]
-
-    return render(request, 'most_listened_genre_per_customer.html', {'data': data})
-
-
-## QUERRIES ##
-
-def genres_per_customer(request):
-    customers = Customer.objects.all()
-    selected_customer_id = request.GET.get('customer_id')
-    data = []
-    customer = None
-
-    if selected_customer_id:
-        customer = Customer.objects.filter(customer_id=selected_customer_id).first()
-        query = """
-            SELECT c.first_name as first_name, c.last_name as last_name, g.name as genre, COUNT(tr.track_id) as track_count
-            FROM customer c
-            LEFT JOIN invoice i ON c.customer_id = i.customer_id
-            LEFT JOIN invoice_line il ON i.invoice_id = il.invoice_id
-            LEFT JOIN track tr ON il.track_id = tr.track_id
-            LEFT JOIN genre g ON tr.genre_id = g.genre_id
-            WHERE c.customer_id = %s
-            GROUP BY c.customer_id, c.first_name, c.last_name, g.genre_id, g.name
-            ORDER BY c.first_name
-        """
-
-        with connection.cursor() as cursor:
-            cursor.execute(query, [selected_customer_id])
-            rows = cursor.fetchall()
-            data = [{'first_name': row[0], 'last_name': row[1], 'genre': row[2], 'track_count': row[3]} for row in rows]
-
-    return render(request, 'genres_per_customer.html', {
-        'customers': customers,
-        'data': data,
-        'customer': customer,
-        'selected_customer_id': selected_customer_id,
-    })
-
-
-def most_popular_artist_per_customer_per_genre(request):
-    customers = Customer.objects.all()
-    selected_customer_id = request.GET.get('customer_id')
-    data = []
-    customer = []
-    if selected_customer_id:
-        query = """WITH PlayCounts AS (
-                SELECT
-                    g.genre_id,
-                    g.name AS genre_name,
-                    ar.name AS artist_name,
-                    COUNT(*) AS play_count
-                FROM customer c
-                JOIN invoice i ON c.customer_id = i.customer_id
-                JOIN invoice_line il ON i.invoice_id = il.invoice_id
-                JOIN track tr ON il.track_id = tr.track_id
-                JOIN genre g ON tr.genre_id = g.genre_id
-                JOIN album a ON tr.album_id = a.album_id
-                JOIN artist ar ON a.artist_id = ar.artist_id
-                WHERE c.customer_id = %s
-                GROUP BY g.genre_id, g.name, ar.name
-            ),
-            MaxPlayCounts AS (
-                SELECT genre_id, MAX(play_count) AS max_count
-                FROM PlayCounts
-                GROUP BY genre_id
-            )
-            SELECT pc.genre_name, pc.artist_name, pc.play_count
-            FROM PlayCounts pc
-            JOIN MaxPlayCounts mpc ON pc.genre_id = mpc.genre_id AND pc.play_count = mpc.max_count;
-        """
-        customer = Customer.objects.filter(customer_id=selected_customer_id).first()
-
-        with connection.cursor() as cursor:
-            cursor.execute(query, [selected_customer_id])
-            rows = cursor.fetchall()
-            data = [{'genre': row[0], 'arist': row[1]} for row in rows]
-
-    return render(request, 'most_popular_artist_per_customer_per_genre.html', {
-        'customers': customers,
-        'customer': customer,
-        'data': data,
-        'selected_customer_id': selected_customer_id,
-    })
-
-
-def invoice_per_customer_after_date(request):
-    customers = Customer.objects.all()
-    selected_customer_id = request.GET.get('customer_id')
-    selected_date = request.GET.get('invoice_date', '2000-01-01')
-    data = []
-    sum = 0
-    customer = None
-
-    if selected_customer_id:
-        customer = Customer.objects.filter(customer_id=selected_customer_id).first()
-        if selected_date:
-            query = """
-                SELECT c.first_name, c.last_name, i.invoice_date::date, i.total
-                FROM customer c
-                JOIN invoice i ON c.customer_id = i.customer_id
-                WHERE c.customer_id = %s AND i.invoice_date > %s
-                ORDER BY i.invoice_date
-            """
-            with connection.cursor() as cursor:
-                cursor.execute(query, [selected_customer_id, selected_date])
-                rows = cursor.fetchall()
-                for r in rows:
-                    sum += r[3]
-
-                data = [{'first_name': row[0], 'last_name': row[1], 'invoice_date': row[2], 'total': row[3]} for row in
-                        rows]
-        else:
-            query = """
-                            SELECT c.first_name, c.last_name, i.invoice_date::date, i.total
-                            FROM customer c
-                            JOIN invoice i ON c.customer_id = i.customer_id
-                            WHERE c.customer_id = %s
-                            ORDER BY i.invoice_date
-                        """
-            with connection.cursor() as cursor:
-                cursor.execute(query, [selected_customer_id])
-                rows = cursor.fetchall()
-                for r in rows:
-                    sum += r[3]
-
-                data = [{'first_name': row[0], 'last_name': row[1], 'invoice_date': row[2], 'total': row[3]}
-                        for row in
-                        rows]
-
-    return render(request, 'invoices_per_customer_after_date.html', {
-        'customers': customers,
-        'total_sum': sum,
-        'data': data,
-        'customer': customer,
-        'selected_customer_id': selected_customer_id,
-    })
-
-
-from django.shortcuts import render, redirect
-from music.models import Employee
-from django.contrib import messages
-
-
-def batch_update_reports_to(request):
-    selected_manager_id = request.POST.get('manager_id') or request.GET.get('manager_id')
-    employees = Employee.objects.exclude(
-        employee_id=selected_manager_id) if selected_manager_id else Employee.objects.all()
-
-    if request.method == 'POST':
-        selected_employee_ids = request.POST.getlist('employee_ids')
-
-        if selected_manager_id and selected_employee_ids:
-            json_data = json.dumps([
-                {"employee_id": int(emp_id), "reports_to_id": int(selected_manager_id)}
-                for emp_id in selected_employee_ids
-            ])
-            try:
-                with connection.cursor() as cursor:
-                    cursor.execute("SELECT batch_update_reports_to(%s::json);", [json_data])
-                messages.success(request, "Batch update successful.")
-                return redirect('batch_update_reports_to')
-
-            except Exception as e:
-                messages.error(request, f"Error during update: {e}")
-
-    all_employees = Employee.objects.all()
-    return render(request, 'batch_update_reports_to.html', {
-        'employees': employees,
-        'all_employees': all_employees,
-        'selected_manager_id': selected_manager_id
-    })
-
-
-def add_tracks_to_playlist(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    invoices = Invoice.objects.all()
-
-    if search_track:
-        tracks = Track.objects.filter(name__icontains=search_track)
-    else:
-        tracks = Track.objects.all()
-
-    playlists = Playlist.objects.all()
-    selected_playlist_id = request.POST.get('playlist_id') or request.GET.get('playlist_id')
-
-    if request.method == 'POST':
-        selected_track_ids = request.POST.getlist('track_ids')
-
-        if selected_playlist_id and selected_track_ids:
-            json_data = json.dumps([
-                {"track_id": int(track_id)}
-                for track_id in selected_track_ids
-            ])
-            try:
-                with connection.cursor() as cursor:
-                    cursor.execute("SELECT add_tracks_to_playlist(%s, %s::json);", [selected_playlist_id, json_data])
-                messages.success(request, "Tracks successfully added to playlist.")
-                return redirect('add_tracks_to_playlist')
-
-            except Exception as e:
-                messages.error(request, f"Error adding tracks: {e}")
-
-    return render(request, 'add_tracks_to_playlist.html', {
-        'playlists': playlists,
-        'tracks': tracks,
-        'selected_playlist_id': selected_playlist_id,
-        'search_track': search_track,
-    })
-
-
-def add_invoice_lines_to_invoice(request):
-    search_track = request.GET.get('search_track', '').strip()
-
-    invoices = Invoice.objects.all().order_by('invoice_id')
-
-    if search_track:
-        tracks = Track.objects.filter(name__icontains=search_track)
-    else:
-        tracks = Track.objects.all()
-
-    selected_invoice_id = request.POST.get('invoice_id') or request.GET.get('invoice_id')
-
-    if request.method == 'POST':
-        selected_track_ids = request.POST.getlist('track_ids')
-        quantities = request.POST.getlist('quantities')
-
-        if selected_invoice_id and selected_track_ids and quantities:
-            try:
-                invoice_lines = []
-                for i in range(len(selected_track_ids)):
-                    track_id = int(selected_track_ids[i])
-                    quantity = int(quantities[i])
-                    invoice_lines.append({'track_id': track_id, 'quantity': quantity})
-
-                json_data = json.dumps(invoice_lines)
-
-                with connection.cursor() as cursor:
-                    cursor.execute("SELECT add_invoice_lines_to_existing_invoice(%s, %s::json);",
-                                   [selected_invoice_id, json_data])
-
-                messages.success(request, "Invoice lines added successfully.")
-                return redirect('add_invoice_lines_to_invoice')
-
-            except Exception as e:
-                messages.error(request, f"Error adding invoice lines: {e}")
-
-    return render(request, 'add_invoice_lines_to_invoice.html', {
-        'invoices': invoices,
-        'tracks': tracks,
-        'selected_invoice_id': selected_invoice_id,
-        'search_track': search_track,
-    })
+def artist_list(request):
+    heading = request.GET.get('model', 'All Artists')
+    data = Artist.objects.values_list('name', flat=True)
+    print(data)
+    return render(request, 'album_list.html', {'data': data, 'heading': heading})
Index: music/views/tracks_count_per_genre.sql
===================================================================
--- music/views/tracks_count_per_genre.sql	(revision d7662b5c5695b63b885011417efd780494e2e537)
+++ music/views/tracks_count_per_genre.sql	(revision d7662b5c5695b63b885011417efd780494e2e537)
@@ -0,0 +1,5 @@
+CREATE VIEW track_count_per_genre AS
+SELECT  g.name as Genre, count(t.track_id) as num_tracks
+FROM genre g
+LEFT JOIN track t on g.genre_id = t.genre_id
+GROUP BY g.name
